/* NitroShare - A simple network file sharing tool.
   Copyright (C) 2012 Nathan Osman

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <QCloseEvent>
#include <QMessageBox>
#include <QPixmap>

#include <dialogs/CFirstStartWizard.h>
#include <util/settings.h>
#include "ui_CFirstStartWizard.h"

CFirstStartWizard::CFirstStartWizard()
    : ui(new Ui::CFirstStartWizard)
{
    ui->setupUi(this);
    setPixmap(LogoPixmap, QPixmap(":/images/config.png"));

    connect(this, SIGNAL(currentIdChanged(int)), SLOT(OnPageChanged(int)));

    /* Load the defaults. */
    ui->MachineName->setText(Settings::Get("General/MachineName").toString());
}

CFirstStartWizard::~CFirstStartWizard()
{
    delete ui;
}

void CFirstStartWizard::OnFinished()
{
    /* Store the settings we have collected. */
    Settings::Set("General/MachineName", ui->MachineName->text());
    Settings::Set("Network/Interface",   ui->BroadcastDiscovery->GetInterface());
}

void CFirstStartWizard::OnPageChanged(int id)
{
    if(id == BroadcastDiscoveryPage)
        ui->BroadcastDiscovery->StartBroadcasting();
}

int CFirstStartWizard::nextId() const
{
    /* Returns the next page to display - we use the default unless
       the user is on the first page and wants to skip this wizard. */
    if(currentId() == WelcomePage && ui->ManualConfigure->isChecked())
        return FinishPage;

    return QWizard::nextId();
}
